%%% File    : security.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created : 30 Nov 2004 by  <svg@surnet.ru>

%%
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsite.db.security).
-author(svg@surnet.ru).

-export([permission_groups/3]).
-export([get_login/2, set_password/3, inc_login_counter/2]).

-import(wsdb).
-import(wslib.str).
-import(wslib.porps).
-import(wslib.passwd).

get_login(Db, LoginId) ->
  case wsdb:read_row(Db, user_login, [{login_id, LoginId}]) of
    {ok, Login} ->
      props:update(password, Login, fun (P) -> passwd:from_string(P) end);
    _ ->
      undefined
  end.

set_password(Db, LoginId, Cipher) ->
  PassStr = passwd:to_string(Cipher),
  {ok, _} = wsdb:do(Db, do_query, ['SET_USER_LOGIN_PASSWORD',
				   [{password, PassStr}, {login_id, LoginId}]
				  ]),
  ok.

inc_login_counter(Db, LoginId) ->
  {ok, _} = wsdb:do(Db, do_query, ['INC_USER_LOGIN_COUNTER', 
				   [{login_id, LoginId}]
				  ]),
  ok.

permission_groups(Db, LoginId, Permission) ->
  Groups = [props:gv(group_id, Row)
	    || Row <- wsdb:select_rows(
			Db, user_login_security_group,
			[{login_id, LoginId}])],
  PermissionGroups =
    [props:gv(group_id, Row)
     || Row <- wsdb:select_rows(
		 Db, security_group_permission,
		 [{permission_id, Permission},
		  {in, group_id, Groups}])],
  [list_to_atom(G) || G <- PermissionGroups].
