%%%-------------------------------------------------------------------
%%% File    : wstldemo.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%%
%%% Created : 26 Feb 2005 by  <svg@surnet.ru>
%%%-------------------------------------------------------------------
%%
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wstldemo).
-author(svg@surnet.ru).

-behaviour(application).

-export([start/0, stop/0, install/0, uninstall/0]).
-export([out/1, init_env/1, update_env/2]).

%% application callbacks
-export([start/2, stop/1, config_change/3]).

-import(wslib.listn).
-import(wslib.props).
-import(wslib.mnesiadb).

-include("wstl.hrl").
-include("wstldemo.hrl").

start() ->
  application:start(wstl),
  ok = application:start(?MODULE).

stop() ->
  application:stop(?MODULE).
  
install() ->
  Nodes = [node()],
  mnesiadb:create_schema(Nodes, database_schema()),
  mnesiadb:init_sequences(Nodes, []).

uninstall() ->
  lists:foreach(fun ({Tab, _}) -> mnesia:delete_table(Tab) end,
		database_schema()).

database_schema() ->
  [?table_def(user_login, [])].

%% application callbacks
start(_, _) ->
  ConfigEntries = application:get_all_env(?MODULE),
  Modules = props:gv(modules, ConfigEntries),
  wstl:start_application(?MODULE, Modules, props:delete(modules, ConfigEntries)).

stop(_) ->
  ok.

config_change(_Changed, _New, _Removed) ->
  ok.

%% wstl callbacks
out(Arg) ->
  Res = (catch wsrun:out(Arg, ?MODULE)),
  Res.

init_env(_Config) ->
  {ok, []}.

update_env(WA, State) ->
  {ok, WA, State}.

